def buildNum = env.BUILD_NUMBER
pipeline{
    agent any   
    environment {
        dotnet ='C:\\Program Files\\dotnet\\'
        jk_aws_id = 'Jenkins Bean stack Deployment' 
    }
    stages{
        stage('Checkout') {
            steps {
                bat "echo Checkout"
                bat "dotnet --version"
                cleanWs()
                checkout scm
            }
        }
        stage('Restore packages'){
            steps{
                bat "dotnet restore"
            }
        }
        stage('Build'){
            steps{
                bat "dotnet build --configuration Release"
            }
        }
        stage('Test: Unit Test'){
            steps{
                bat "echo unit testing step"
                // bat "dotnet test --configuration Release"
            }
        }
        stage('Publish'){
            steps{
                bat "dotnet publish -o site"
                powershell(returnStdout: true, script: 'compress-archive -path .\\site\\* -destinationpath \'site.zip\' -compressionlevel optimal')
                // bat "compress-archive -path .\\site\\* -destinationpath 'site.zip' -compressionlevel optimal"
                bat "mkdir binaries"
                powershell(returnStdout: true, script: 'Copy-Item -LiteralPath site.zip,aws-windows-deployment-manifest.json -Destination binaries')
                // bat "Copy-Item -LiteralPath site.zip,aws-windows-deployment-manifest.json -Destination binaries"
            }
        }
        stage('Saving to Elastic Beanstalk and Deploy'){
            environment{ 
                gcs = "${bat(script:'echo ${GIT_COMMIT:0:8}', returnStdout: true).trim()}" 
            }
            steps{
                step([$class: 'AWSEBDeploymentBuilder', 
                credentialId: "${jk_aws_id}", 
                awsRegion: 'us-east-1', 
                applicationName: 'my-core5-app', 
                environmentName: 'Mycore5app-env', 
                rootObject: './binaries', 
                includes: '**/*',     
                excludes: '', 
                bucketName: 'elasticbeanstalk-us-east-1-250807526657', 
                keyPrefix: 'my-core5-app/builds/prod-env/', 
                versionLabelFormat: "${buildNum}",
                versionDescriptionFormat: "${buildNum}", 
                sleepTime: '10', 
                checkHealth: 'true', 
                maxAttempts: '12' ])
            }
        }
    }
    // post{
    //     always{
    //         emailext body: "${currentBuild.currentResult}: Job   ${env.JOB_NAME} build ${env.BUILD_NUMBER}\n More info at: ${env.BUILD_URL}",
    //         recipientProviders: [[$class: 'DevelopersRecipientProvider'], [$class: 'RequesterRecipientProvider']],
    //         subject: "Jenkins Build ${currentBuild.currentResult}: Job ${env.JOB_NAME}"
    //     }
    // }
}